#!/bin/bash
# http://www.lua.org
# script : til <rob DOT til DOT freedman AT googlemail DOT com>
REPO=http://zenwalk.pinguix.com/user-accounts/tilderb
set -u -e -x

#lua
version=5.1.4
build=64.1
arch=i486
tune=i686

PKG_DEP=''
PKG_SRC="$REPO/extra/ap/lua/build-lua.sh
http://www.lua.org/ftp/lua-5.1.4.tar.gz"
#
#for url in $PKG_SRC;do [ ! -e ${url##*/} ] && wget -N $url; done

pkgname=lua-$version
package=$pkgname-$arch-$build

CWD=$(pwd)
TMP=${TMP:-$CWD}
SRC=$TMP/$pkgname
PKG=$TMP/$package

[ -d $SRC ] && rm -fr $SRC
[ -d $PKG ] && rm -fr $PKG

mkdir -p $PKG/{install,usr/{src,doc}/$pkgname}

# extract_source
tar xf $CWD/$pkgname.tar.gz -C $TMP
cd $SRC
export CFLAGS="-O2 -march=$arch -mtune=$tune"

patch -Np1 -i $CWD/lua-arch.patch || exit 1

make linux LUA_SO=liblua.so
make \
	INSTALL_DATA="cp -d" \
	INSTALL_TOP=$PKG/usr \
	INSTALL_MAN=$PKG/usr/man/man1 \
	TO_LIB="liblua.a liblua.so liblua.so.5.1" \
	linux install

install -Dm644 etc/lua.pc $PKG/usr/lib/pkgconfig/lua.pc

# docs
cp -a COPYRIGHT HISTORY README doc/* \
	$PKG/usr/doc/$pkgname
# examples
mkdir $PKG/usr/doc/$pkgname/examples
cp -a test/* $PKG/usr/doc/$pkgname/examples

cd $PKG
# zip man pages
if [ -d usr/man/man1 ]; then
   find usr/man/man1 -type f -exec gzip -9 {} \;
fi

# strip symbols
find . | xargs file | grep -e "executable" -e "shared object" | grep ELF |\
	cut -f 1 -d : | xargs -r strip --strip-unneeded 2> /dev/null

find . |xargs file |grep "current ar archive" |\
	cut -f 1 -d : |xargs -r strip -g

# slackdesc
#  |-----handy-ruler------------------------------------------------------|
cat <<EOF > install/slack-desc
lua: lua (A powerful, lightweight programming language)
lua:
lua: Lua can be used as a general-purpose, stand-alone language
lua: or for extending applications.
lua: 
EOF

cp $CWD/build-lua.sh usr/src/$pkgname

# done
fakeroot /sbin/makepkg -l y -c n $CWD/$package.txz

cd $CWD
depfinder $PKG >$package.dep
#echo -n $PKG_DEP > $package.dep
md5sum $package.txz > $package.md5
